<template>
  <table class="odv__table">
    <tbody>
    <template v-if="firstRecord">
      <tr>
        <th scope="row" :style="iconStyles" v-html="thermometerIcon"></th>
        <td>{{ minMaxTemp.min && minMaxTemp.min.toFixed(1) }}&deg;</td>
        <td>&#45;</td>
        <td>{{ minMaxTemp.max && minMaxTemp.max.toFixed(1) }}&deg;</td>
      </tr>
      <tr>
        <th scope="row" :style="iconStyles" v-html="sunIcon"></th>
        <td>
          <time>{{ sunriseSunset.sunrise }}</time>
        </td>
        <td>&#45;</td>
        <td>
          <time>{{ sunriseSunset.sunset }}</time>
        </td>
      </tr>
    </template>
    <tr v-else>
      <td rowspan="2">{{t("no_data_msg")}}</td>
    </tr>
    </tbody>
  </table>
</template>

<script>
module.exports = {
  name: "owm-daily-values",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    currentDimensions: {
      type: Object,
      required: true
    },
    currentStyles: {
      type: Object,
      required: true
    },
    records: {
      type: Array,
      required: false
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: false
    }
  },
  asyncComputed: {
    sunIcon: function () {
      return this.fetchAsset("icons", "sun.svg");
    },
    thermometerIcon: function () {
      return this.fetchAsset("icons", "thermometer.svg");
    }
  },
  computed: {
    iconStyles: function () {
      return {
        height: `${(this.currentStyles.fontSize / 100)}rem`
      }
    },
    firstRecord: function () {
      return this.records[0];
    },
    sunriseSunset: function () {
      const cityData = this.firstRecord && this.firstRecord.attributes;
      if (cityData && cityData.sunrise && cityData.sunset) {
        return {
          sunrise: this.formatTime(Date.parse(cityData.sunrise)),
          sunset: this.formatTime(Date.parse(cityData.sunset))
        };
      } else {
        return {
          sunrise: undefined,
          sunset: undefined
        };
      }
    },
    minMaxTemp: function () {
      const firstRecordOfTomorrow = ((24 / 8) % new Date().getHours()) + 1;
      try {
        return this.firstRecord.attributes.entries
            .slice(0, firstRecordOfTomorrow)
            .reduce(
                (acc, record, idx) => {
                  // Initializing with null or zero throws off Math.min, so we need to handle the first iteration differently.
                  if (idx === 0) {
                    acc.min = record.forecast.main.temp;
                    acc.max = record.forecast.main.temp;
                  } else {
                    acc.min = Math.min(record.forecast.main.temp, acc.min);
                    acc.max = Math.max(record.forecast.main.temp, acc.max);
                  }
                  return acc;
                },
                {min: undefined, max: undefined}
            );
      } catch (error) {
        return {min: undefined, max: undefined}
      }
    }
  },
  methods: {
    formatTime: function (timestamp) {
      return new Intl.DateTimeFormat(this.language, {
        hour: "2-digit",
        minute: "2-digit"
      }).format(timestamp);
    }
  },
  locales: {
    enGb: {
      no_data_msg: "No usable weather data"
    },
    deDe: {
      no_data_msg: "keine nutzbaren Wetterdaten"
    },
    frFr: {
      no_data_msg: "pas de données météorologiques"
    },
    esEs: {
      no_data_msg: "No hay datos meteorológicos"
    },
    plPl: {
      no_data_msg: "Brak użytkowych danych pogodowych"
    },
    koKr: {
      no_data_msg: "사용 가능한 날씨 데이터가 없습니다"
    }
  }
};
</script>
<style>
.odv__table {
  border-spacing: 0.125rem 0.1665rem;
  table-layout: fixed;
}
.odv__table svg {
  height: inherit;
  vertical-align: middle;
}
</style>
